SELECT merge_by_key_version();

CREATE TEMP TABLE merge_test
 (i int, j int, k int, f int, PRIMARY KEY(i, j));
INSERT INTO merge_test VALUES (1, 1, 1);
INSERT INTO merge_test VALUES (1, 2, 1);
INSERT INTO merge_test VALUES (2, 1, 1);
INSERT INTO merge_test VALUES (2, 2, 1);
INSERT INTO merge_test VALUES (5, 1, 1);
SELECT * FROM merge_test;

SELECT
 create_count,
 update_using_count,
 delete_using_count,
 insert_count
FROM merge_by_key('merge_test',
 'SELECT i, j, k + 1 AS k, f FROM merge_test');
SELECT * FROM merge_test;

UPDATE merge_test SET k = 1 WHERE i = 1 AND j = 1;
SELECT
 create_count,
 update_using_count,
 delete_using_count,
 insert_count
FROM merge_by_key('merge_test', 'mnew.k = 2',
 'SELECT i, j, k + 1 AS k, f FROM merge_test');

SELECT * FROM merge_test;

CREATE TEMP TABLE _some_merge_data
 (i int, j int, f int, other text, k int DEFAULT 1);
INSERT INTO _some_merge_data VALUES (1, 1, 5, 'foobar');

-- Also checks to make sure superfluous columns are not referenced. (other)
SELECT
 create_count,
 update_using_count,
 delete_using_count,
 insert_count
FROM merge_by_key('merge_test', ARRAY['k'::text],
 'SELECT * FROM _some_merge_data'
);
SELECT * FROM merge_test;

DELETE FROM _some_merge_data;
INSERT INTO _some_merge_data VALUES (1, 1, NULL, 'bleh');
SELECT
 create_count,
 update_using_count,
 delete_using_count,
 insert_count
FROM merge_by_key(
 'merge_test', ARRAY['k'::text],
 'SELECT * FROM _some_merge_data'
);
SELECT * FROM merge_test;

-- Check to make sure NULLs are properly compared for updates
DELETE FROM _some_merge_data;
INSERT INTO _some_merge_data VALUES (1, 1, NULL, 'bar', 27);
SELECT
 create_count,
 update_using_count,
 delete_using_count,
 insert_count
FROM merge_by_key(
 'merge_test',
 'SELECT * FROM _some_merge_data'
);
SELECT * FROM merge_test;
DELETE FROM _some_merge_data;
INSERT INTO _some_merge_data VALUES (1, 1, NULL, 'bar', 27);
SELECT
 create_count,
 update_using_count,
 delete_using_count,
 insert_count
FROM merge_by_key('merge_test',
 'SELECT * FROM _some_merge_data'
);

-- Look at log to check that exact delete = 1.
SELECT * FROM merge_test;

-- ignore the absent columns for the merge.
SELECT
 create_count,
 update_using_count,
 delete_using_count,
 insert_count
FROM merge_by_key('merge_test',
 'SELECT 1 AS i, 1 AS j, 7 AS f');
SELECT * FROM merge_test;

SELECT
 create_count,
 update_using_count,
 delete_using_count,
 insert_count
FROM merge_by_key('merge_test',
 'SELECT 3 AS i, 3 AS j, 27 AS k'
);
SELECT * FROM merge_test;
